unit test_hide1;

{$mode objfpc}{$H+}

interface

uses fpstypes, fpscsv, fpspreadsheetctrls, fpspreadsheet, fpsallformats,
  fpspreadsheetgrid, fpsexport, SysUtils, Forms, Dialogs, StdCtrls, ExtCtrls,
  EditBtn, Buttons, Classes, fpdbfexport, dbf, db, Grids, Controls, DBGrids;

type

  { TForm1 }

  TForm1 = class(TForm)
    bt1Open: TButton;
    bt2Save: TButton;
    bt3HideAll: TButton;
    bt4ShowAll: TButton;
    bt6HideCurrent: TButton;
    cb1Sheets: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    sCellEdit1: TsCellEdit;
    sCellIndicator1: TsCellIndicator;
    sWorkbookTabControl1: TsWorkbookTabControl;
    Grid1: TsWorksheetGrid;
    wbSource1: TsWorkbookSource;
    procedure bt3HideAllClick(Sender: TObject);
    procedure bt4ShowAllClick(Sender: TObject);
    procedure bt1OpenClick(Sender: TObject);
    procedure bt2SaveClick(Sender: TObject);
    procedure cb1SheetsChange(Sender: TObject);
    procedure bt6HideCurrentClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }


procedure TForm1.bt1OpenClick(Sender: TObject);
var t1, t2: double;
begin
  if OpenDialog1.Execute then
    begin
      wbSource1.FileName := OpenDialog1.FileName;
      caption := OpenDialog1.FileName;
      Grid1.GetSheets(cb1Sheets.items);
      cb1Sheets.Text := cb1Sheets.items[0]
    end;
end;

procedure TForm1.bt3HideAllClick(Sender: TObject);
var ii: integer;
begin
  for ii:= 0 to wbSource1.Workbook.GetWorksheetCount -1 do
    with wbSource1.Workbook.GetWorksheetByIndex(ii) do
      Options:= Options + [soHidden];
end;

procedure TForm1.bt4ShowAllClick(Sender: TObject);
var ii: integer;
begin
  for ii:= 0 to wbSource1.Workbook.GetWorksheetCount -1 do
    with wbSource1.Workbook.GetWorksheetByIndex(ii) do
      Options:= Options - [soHidden];
end;

procedure TForm1.bt2SaveClick(Sender: TObject);
begin
  wbSource1.SaveToSpreadsheetFile(caption);
end;

procedure TForm1.cb1SheetsChange(Sender: TObject);
var sht: string;
begin
  sht := cb1Sheets.Text;;

{  ws := wbSource1.workbook.GetWorksheetByName(sht);
  if soHidden in ws.Options then
    showmessage('Hidden');
  ws := nil;
 }

  with wbSource1.workbook.GetWorksheetByName(sht) do //book.GetWorksheetByName(sht)   do
    begin
 //     ws := workbook.GetWorksheetByName(sht);
      if soHidden in Options then
        begin
          Label1.Caption := sht + ' is hidden';
  //        Label1.Hint := 'Click here to Unhide ' + sht;
//          Label1.OnClick:= @Label1_UnhideClick;
        end
      else
        begin
          Label1.Caption := sht + ' is NOT hidden';
    //      Label1.Hint := 'Click here to Hide ' + sht;
    //      Label1.OnClick:= @Label1_HideClick;
        end;
    end;
//  bt5HideSheet.Caption := 'Hide ' + cb1Sheets.Text;
end;

procedure TForm1.bt6HideCurrentClick(Sender: TObject);
begin
  with wbSource1.worksheet do
    Options:= Options + [soHidden];
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  caption := ChangeFileExt(Application.ExeName, '.xlsx');
  OpenDialog1.Filename := caption;
  wbSource1.FileName:= caption;
  Grid1.GetSheets(cb1Sheets.items);
  cb1Sheets.ItemIndex := 0 ;
end;

end.

